
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅谈TCP优化 / iVAN</title>

    <meta name="description" content="浅谈TCP优化 原文地址:http://kb.cnblogs.com/page/197406/ 很多人常常对TCP优化有一种雾里看花的感觉,实际上只要理解了TCP的运行方式就能掀开它的神秘面纱.Ilya Grigorik 在「High Performance Browser Networking」中做了很多细致的描述,让人读起来醍醐灌顶,我大概总结了一下,以期更加通俗易懂. 流量控制 传输数据的时候,如果发送方传输的数据量超过了接收方的处理能力,那么接收方会出现丢包.为了避免出现此类问题,流量控制要求数据传输双">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">浅谈TCP优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文地址：http://kb.cnblogs.com/page/197406/</p>
<p>很多人常常对<a href="http://www.psc.edu/index.php/networking/641-tcp-tune" rel="external nofollow noreferrer">TCP优化</a>有一种雾里看花的感觉，实际上只要理解了TCP的运行方式就能掀开它的神秘面纱。<a href="http://www.igvita.com/" rel="external nofollow noreferrer">Ilya Grigorik</a> 在「<a href="http://chimera.labs.oreilly.com/books/1230000000545/index.html" rel="external nofollow noreferrer">High Performance Browser Networking</a>」中做了很多细致的描述，让人读起来醍醐灌顶，我大概总结了一下，以期更加通俗易懂。</p>
<h2>　　流量控制</h2>
<p>　　传输数据的时候，如果发送方传输的数据量超过了接收方的处理能力，那么接收方会出现丢包。为了避免出现此类问题，流量控制要求数据传输双方在每次交互时声明各自的接收窗口「rwnd」大小，用来表示自己最大能保存多少数据，这主要是针对接收方而言的，通俗点儿说就是让发送方知道接收方能吃几碗饭，如果窗口衰减到零，那么就说明吃饱了，必须消化消化，如果硬撑的话说不定会大小便失禁，那就是丢包了。</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238491762.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvZmxvd19jb250cm9sLnBuZw==.jpg"></a></p>
<p>Flow Control</p>
<p>　　接收方和发送方的称呼是相对的，如果站在用户的角度看：当浏览网页时，数据以下行为主，此时客户端是接收方，服务端是发送方；当上传文件时，数据以上行为主，此时客户端是发送方，服务端是接收方。</p>
<h2>　　慢启动</h2>
<p>　　虽然流量控制可以避免发送方过载接收方，但是却无法避免过载网络，这是因为接收窗口「rwnd」只反映了服务器个体的情况，却无法反映网络整体的情况。</p>
<p>　　为了避免过载网络的问题，慢启动引入了拥塞窗口「cwnd」的概念，用来表示发送方在得到接收方确认前，最大允许传输的未经确认的数据。「cwnd」同「rwnd」相比不同的是：它只是发送方的一个内部参数，无需通知给接收方，其初始值往往比较小，然后随着数据包被接收方确认，窗口成倍扩大，有点类似于拳击比赛，开始时不了解敌情，往往是次拳试探，慢慢心里有底了，开始逐渐加大重拳进攻的力度。</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238496447.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvc2xvd19zdGFydC5wbmc=.jpg"></a></p>
<p>Slow Start</p>
<p>　　在慢启动的过程中，随着「cwnd」的增加，可能会出现网络过载，其外在表现就是丢包，一旦出现此类问题，「cwnd」的大小会迅速衰减，以便网络能够缓过来。</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238527691.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvY29uZ2VzdGlvbl9hdm9pZGFuY2UucG5n.jpg"></a></p>
<p>Congestion Avoidance</p>
<p>　　说明：网络中实际传输的未经确认的数据大小取决于「rwnd」和「cwnd」中的小值。</p>
<h2>　　拥塞避免</h2>
<p>　　从慢启动的介绍中，我们能看到，发送方通过对「cwnd」大小的控制，能够避免网络过载，在此过程中，丢包与其说是一个网络问题，倒不如说是一种反馈机制，通过它我们可以感知到发生了网络拥塞，进而调整数据传输策略，实际上，这里还有一个慢启动阈值「ssthresh」的概念，如果「cwnd」小于「ssthresh」，那么表示在慢启动阶段；如果「cwnd」大于「ssthresh」，那么表示在拥塞避免阶段，此时「cwnd」不再像慢启动阶段那样呈指数级整整，而是趋向于线性增长，以期避免网络拥塞，此阶段有多种算法实现，通常保持缺省即可，这里就不一一说明了，有兴趣的读者可以自行查阅。</p>
<p>　　…</p>
<h2>　　如何调整「rwnd」到一个合理值</h2>
<p>　　有很多人都遇到过网络传输速度过慢的<a href="http://www.onlamp.com/pub/a/onlamp/2005/11/17/tcp_tuning.html" rel="external nofollow noreferrer">问题</a>，比如说明明是百兆网络，其最大传输数据的理论值怎么着也得有个十兆，但是实际情况却相距甚远，可能只有一兆。此类问题如果剔除奸商因素，多半是由于接收窗口「rwnd」设置不合理造成的。</p>
<p>　　实际上接收窗口「rwnd」的合理值取决于<a href="http://en.wikipedia.org/wiki/Bandwidth-delay_product" rel="external nofollow noreferrer">BDP</a>的大小，也就是带宽和延迟的乘积。假设带宽是 100Mbps，延迟是 100ms，那么计算过程如下：</p>
<pre>BDP = 100Mbps * 100ms = (100 / 8) * (100 / 1000) = 1.25MB</pre>
<p>　　此问题下如果想最大限度提升吞度量，接收窗口「rwnd」的大小不应小于1.25MB。说点引申的内容：TCP使用16位来记录窗口大小，也就是说最大值是64KB，如果超过它，就需要使用tcp_window_scaling机制。参考：<a href="http://packetlife.net/blog/2010/aug/4/tcp-windows-and-window-scaling/" rel="external nofollow noreferrer">TCP Windows and Window Scaling</a>。</p>
<p>　　Linux中通过配置内核参数里接收缓冲的大小，进而可以控制接收窗口的大小：</p>
<pre>shell&gt; sysctl -a | grep memnet.ipv4.tcp_rmem = &lt;MIN&gt; &lt;DEFAULT&gt; &lt;MAX&gt;</pre>
<p>　　如果我们出于传输性能的考虑，设置了一个足够大的缓冲，那么当大量请求同时到达时，内存会不会爆掉？通常不会，因为Linux本身有一个缓冲大小自动调优的机制，窗口的实际大小会自动在最小值和最大值之间浮动，以期找到性能和资源的平衡点。</p>
<p>　　通过如下方式可以确认缓冲大小自动调优机制的状态（0：关闭、1：开启）：</p>
<pre>shell&gt; sysctl -a | grep tcp_moderate_rcvbuf</pre>
<p>　　如果缓冲大小自动调优机制是关闭状态，那么就把缓冲的缺省值设置为BDP；如果缓冲大小自动调优机制是开启状态，那么就把缓冲的最大值设置为BDP。</p>
<p>　　实际上这里还有一个细节问题是：缓冲里除了保存着传输的数据本身，还要预留一部分空间用来保存TCP连接本身相关的信息，换句话说，并不是所有空间都会被用来保存数据，相应额外开销的具体计算方法如下：</p>
<blockquote><p>Buffer / 2^tcp_adv_win_scale</p></blockquote>
<p>　　依照Linux内核版本的不同，net.ipv4.tcp_adv_win_scale 的值可能是 1 或者 2，如果为 1 的话，则表示二分之一的缓冲被用来做额外开销，如果为 2 的话，则表示四分之一的缓冲被用来做额外开销。按照这个逻辑，缓冲最终的合理值的具体计算方法如下：</p>
<blockquote><p>BDP / (1 – 1 / 2^tcp_adv_win_scale)</p></blockquote>
<p>　　此外，提醒一下延迟的测试方法，BDP中的延迟指的就是RTT，通常使用ping命令很容易就能得到它，但是如果 ICMP 被屏蔽，ping也就没用了，此时可以试试 <a href="https://gist.github.com/anonymous/5926902" rel="external nofollow noreferrer">synack</a>。</p>
<h2>　　如何调整「cwnd」到一个合理值</h2>
<p>　　一般来说「cwnd」的初始值取决于<a href="http://en.wikipedia.org/wiki/Maximum_segment_size" rel="external nofollow noreferrer">MSS</a>的大小，计算方法如下：</p>
<blockquote><p>min(4 * MSS, max(2 * MSS, 4380))</p></blockquote>
<p>　　以太网标准的MSS大小通常是1460，所以「cwnd」的初始值是3MSS。</p>
<p>　　当我们浏览视频或者下载软件的时候，「cwnd」初始值的影响并不明显，这是因为传输的数据量比较大，时间比较长，相比之下，即便慢启动阶段「cwnd」初始值比较小，也会在相对很短的时间内加速到满窗口，基本上可以忽略不计。</p>
<p>　　不过当我们浏览网页的时候，情况就不一样了，这是因为传输的数据量比较小，时间比较短，相比之下，如果慢启动阶段「cwnd」初始值比较小，那么很可能还没来得及加速到满窗口，通讯就结束了。这就好比博尔特参加百米比赛，如果起跑慢的话，即便他的加速很快，也可能拿不到好成绩，因为还没等他完全跑起来，终点线已经到了。</p>
<p>　　举例：假设网页20KB，MSS大小1460B，如此说来整个网页就是15MSS。</p>
<p>　　先让我们看一下「cwnd」初始值比较小（等于4MSS）的时候会发生什么：</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238496603.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvc21hbGxfd2luZG93LnBuZw==.jpg"></a></p>
<p>Small Window</p>
<p>　　再看一下「cwnd」初始值比较大（大于15MSS）的时候又会如何：</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238521911.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvYmlnX3dpbmRvdy5wbmc=.jpg"></a></p>
<p>Big Window</p>
<p>　　明显可见，除去TCP握手和服务端处理，原本需要三次RTT才能完成的数据传输，当我们加大「cwnd」初始值之后，仅用了一次RTT就完成了，效率提升非常大。</p>
<p>　　推荐：大拿 <a href="http://www.mnot.net/" rel="external nofollow noreferrer">mnot</a> 写了一个名叫 <a href="https://github.com/mnot/htracr" rel="external nofollow noreferrer">htracr</a> 的工具，可以用来<a href="http://www.mnot.net/blog/2010/11/27/htracr" rel="external nofollow noreferrer">测试</a>相关的影响。</p>
<p>　　既然加大「cwnd」初始值这么好，那么到底应该设置多大为好呢？Google在这方面做了大量的<a href="https://developers.google.com/speed/protocols/tcpm-IW10" rel="external nofollow noreferrer">研究</a>，权衡了效率和稳定性之后，最终给出的建议是10MSS。如果你的Linux版本不太旧的话，那么可以通过如下方法来调整「cwnd」初始值：</p>
<pre>shell&gt; ip route | while read p; do ip route change $p initcwnd 10; done</pre>
<p>　　需要提醒的是片面的提升发送端「cwnd」的大小并不一定有效，这是因为前面我们说过网络中实际传输的未经确认的数据大小取决于「rwnd」和「cwnd」中的小值，所以一旦接收方的「rwnd」比较小的话，会阻碍「cwnd」的发挥。</p>
<p>　　推荐：相关详细的描述信息请参考：<a href="http://www.cdnplanet.com/blog/tune-tcp-initcwnd-for-optimum-performance/" rel="external nofollow noreferrer">Tuning initcwnd for optimum performance</a>。</p>
<p>　　有时候我们可能想检查一下目标服务器的「cwnd」初始值设置，此时可以数包：</p>
<p><a href="http://images.cnitblog.com/news/1/201401/082238493791.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaHVvZGluZy5jb20vd3AtY29udGVudC91cGxvYWRzLzIwMTMvMTEvdGVzdF9pbml0Y3duZC5wbmc=.jpg"></a></p>
<p>Test Initcwnd</p>
<p>　　通过握手阶段确认RTT为168，开始传输后得到第一个数据包的时间是409，加上RTT后就是577，从409到577之间有两个数据包，所以「cwnd」初始值是2MSS。</p>
<p>　　需要额外说明的是，单纯数包可能并不准确，因为网卡可能会对包做点手脚，具体说明信息请参考：<a href="http://sandilands.info/sgordon/segmentation-offloading-with-wireshark-and-ethtool" rel="external nofollow noreferrer">Segmentation and Checksum Offloading: Turning Off with ethtool</a>。</p>
<p>　　补充：有人写了一个名叫 <a href="https://github.com/redhands/initcwnd_check" rel="external nofollow noreferrer">initcwnd_check</a> 的脚本，可以帮你检查「cwnd」初始值。</p>
<p>　　…</p>
<p>　　实践是检验真理的唯一标准，希望大家多动手，通过实验来检验结果，推荐一篇不错的文章：<a href="http://sandilands.info/sgordon/impact-of-bandwidth-delay-product-on-tcp-throughput" rel="external nofollow noreferrer">Impact of Bandwidth Delay Product on TCP Throughput</a>，此外知乎上的讨论也值得一看：<a href="http://www.zhihu.com/question/21813579/answer/19402704" rel="external nofollow noreferrer">为什么多 TCP 连接分块下载比单连接下载快</a>，大家有货的话也请告诉我。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 07:50:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/linux/" title="linux">linux</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>浅谈TCP优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zG17kkM.html" rel="bookmark">浅谈TCP优化&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多人常常对TCP优化有一种雾里看花的感觉,实际上只要理解了TCP的运行方式就能掀开它的神秘面纱.Ilya Grigorik 在「High Performance Browser Networking」中做了很多细致的描述,让人读起来醍醐灌顶,我大概总结了一下,以期更加通俗易懂. 流量控制 传输数据的时候,如果发送方传输的数据量超过了接收方的处理能力,那么接收方会出现丢包.为了避免出现此类问题,流量控制要求数据传输双方在每次交互时声明各自的接收窗口「rwnd」大小,用来表示自己最大能保存多少数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zG8OVlb.html" rel="bookmark">浅谈TCP&sol;IP优化方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多人常常对TCP优化有一种雾里看花的感觉,实际上只要理解了TCP的运行方式就能掀开它的神秘面纱.Ilya Grigorik 在「High Performance Browser Networking」中做了很多细致的描述,让人读起来醍醐灌顶,我大概总结了一下,以期更加通俗易懂.   流量控制 传输数据的时候,如果发送方传输的数据量超过了接收方的处理能力,那么接收方会出现丢包.为了避免出现此类问题,流量控制要求数据传输双方在每次交互时声明各自的接收窗口「rwnd」大小,用来表示自己最大能保存多少			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bon6Vz.html" rel="bookmark">浅谈SEO优化的三大误区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				seo需要的是我们亲自动手的能力,绝不是人云亦云,因为有一些道理不是随口说说就能够明白,在搜索引擎不断变化的今天,每一次的调整,都有人做总结;每一次的更新,都会有他的道理,现在无论在什么地方,关于seo的分析总是有很多,相信经常在seo论坛上和A5论坛上逛的朋友,总是可以看到很多理论派的seo文章,这些观点都认同吗,那么,这些分析之中,自己就浅谈下有哪些seo不同的观点吧. 一:seo外链和排名的关系,外链越多,排名越好吗? 每一位seo都知道外链的重要性,每天的工作任务之一就是发外链,每天的任			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/lpPV7Zb.html" rel="bookmark">时间就是金钱 浅谈SEO优化与时间</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				时间就是金钱,往往告诉人们要抓紧时间,不要等待时间的流失.没错,这就是时间.可是对于我们站长来说,时间就是金钱,可能和这个意思有点儿不同,我们的时间要能够沉淀成为历史,让我们的网站有一定的历史背景. 比如建立一个月的站,建立了半年的站,两个站龄往往也会决定网站的成败,Seo需要时间,就是众所周知的,但是很多站长 不懂得真正&quot;需要时间&quot;这四个字的含义,很多站长对网站优化完了之后,就开始了漫长的,毫无目的地等待.在这里面,本人做为新手,希望能够和大家一起探谈一下SEO与时间的问题. 我也一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pLr10b.html" rel="bookmark">浅谈seo优化经验心得</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近日,本人帮一个学校优化一个城市中心招生信息网站,网站是用帝国cms开发的,内容很多分布也很广.但是网站并没有测试检验过,就把它交给了我,让我去优化推广.但经过我熟悉测试后,发现网站LJ的很,有一大堆漏洞和错误,还有很多功能都未实现.总之,网站很不美观.很不专业.好了,说了那么多废话.现在谈谈我这段时间的seo心得.经过这个月的seo经历和我对seo的理解,得出了这样一个比喻,seo优化就好比栽培一棵树,而开发网站就是种一棵树.树苗质量的好坏决定着以后能不能茁壮成长.如果你种的树苗就不健康,那能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9MxLgjM.html" rel="bookmark">浅谈seo优化基本技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于工作需要,本人简单的分析总结了一下seo优化的基本技巧,下面给大家分享一下. 1. 认识seo seo简单的说就是搜索引擎优化. 2. seo作用:经过seo优化的网站更容易被搜索引擎收录,更容易提高网站的关键字在搜索引擎中的排名,从而提高网站的流量和排名! 3. seo的影响因素有3点:网站的内容和功能.域名.主机. a.网站的内容和功能.开发一个网站就像种一棵树,而seo优化网站就像栽培一棵树.种一棵树并不难,但要把这棵树栽培好,让它茁壮成长起来并不是一件易事,需要花费巨大的时间和精力.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5ld6M.html" rel="bookmark">浅谈SEO优化： &OpenCurlyDoubleQuote;内容为王，外链为皇&rdquo;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				纵观2011年网站的发展,网站的内容,外链接的建设,仍然以非常重要的因素影响着网站的排名,网站在做SEO优化时经常会听到这句话,想必大家都不陌生:内容为王,外链为皇&quot;,之所以这样说,就足以证明网站内容和外链在网站发展中的重要性.今天我就从这两点来为大家详细的解答一下.希望和更多的站长们分享经验,让网站持续稳步的发展起来. 一:网站内容的坚持更新 说到网站内容,我想很多的站长都知道伪原创,我们国内的网站SEO优化现在主要也是针对百度而言的.百度不得不说已经在所有的搜索引擎中处于界乎于垄断的地位.百			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apX3EKM.html" rel="bookmark">浅谈如何优化使长尾关键词有排名</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				    目标关键词竞争过大,一时半会自己的网站排名上不来,那么这样就说自己网站不能有流量了吗?长尾关键词的出现,使得小站长们在夹缝中求得一个生存的机会.很多的搜索量大的关键词都被一些老站所揽括了.那么咱们要做这种词的难度可想而知,不但要拼技术.拼外链.拼优化,还要拼执行力.所以,咱们就要退而求次,选择与之相关的长尾关键词,长尾关键词的表达方式主要有以短句.加上语气助词.偏长的句子的形式出现.今天笔者主要说说怎么样让长尾关键词快速获得排名. 首先是网站内容.每个站长都知道原创内容是最受搜索引挚和用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMNRDPM.html" rel="bookmark">浅谈网站优化必须注意的细节</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.网站定位要准确: 这直接影响到网站的发展方向或者说命运.网站定位不仅仅包括网站关键字的选取,更重要的是包含了你对网站有什么样的规划,你打算让你的网站在三年以后变成什么样的一个情况,是本地区的浑浑噩噩勒?还是全国知名.或者,你的受众是广大女性还是仅仅是20-40岁的女性??你的网站是供知?供需还是供欲??这些都要提前规划好. 2.网站空间要稳定: 这是一个绝对影响你网站命脉的问题,试想一下,你访问某网站,1秒没打开,2秒还是没打开......过了10秒还没打开.那么你会怎么做??肯定会直接关掉			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnY4rM.html" rel="bookmark" class="title">【Shell】fix 1032报错信息的脚本</a>
					<div>
						 生产环境总会遇到由于各种原因导致的主从复制不一致的情况,导致slave出现 1032报错.为了使主从关系能够稳定的运行,大多时候可以选择修复1032 报错 ,先跳过去 ,然后使用 percona   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvqdWb.html" rel="bookmark" class="title">静态页中利用AJAX&period;NET实现无刷新页面</a>
					<div>
						ajax|静态|刷新|无刷新|页面 一. 导言 我们知道,ASP.net应用程序事实是在服务器上运行的,用户的请求要不断地送往远程的服务器,服务器执行完本地的程序后把重新装载页面再发送客户端.所以就出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqq5YM.html" rel="bookmark" class="title">Geometry 对象浅析</a>
					<div>
						ArcEngine Geometry库定义了基本几何图形的矢量表达形式,顶级的几何图形有Points.Multipoints.Polylines.Polygons. Multipatches,Geod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW54nz.html" rel="bookmark" class="title">思科公司PIX防火墙全系列产品一览&lpar;2&rpar;</a>
					<div>
						 PIX 525 产品要点和应用环境 Cisco PIX 525防火墙应用环境 Cisco Secure PIX 525防火墙是世界领先的Cisco Secure PIX防火墙系列的组成部分,能够为当 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3mNAp.html" rel="bookmark" class="title">黄明明归国创业寻觅伙伴：人品好是必要条件</a>
					<div>
						两年前,32岁的黄明明从美国归来,整天游走在互联网业界,寻觅着商业机会和创业伙伴. 一开始,他将目光锁定在一些比较大且已成型的互联网公司,但一个偶然的机会,使黄在北京四合院里找到他第一个创业伙伴A.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M0Ay7p.html" rel="bookmark" class="title">如何用ISO镜像文件引导Windows系统</a>
					<div>
						对于那些未安装软驱的朋友来说,大多数都会选择虚拟软驱,但可惜的是虚拟软驱的容量毕竟太小,这样在功能上就不得不受到一些限制. ISOEMU是一款比较有趣的软件,安装后可以借助硬盘上的ISO镜像文件引导系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2onab.html" rel="bookmark" class="title">多线程编程&lpar;17&rpar;</a>
					<div>
						根据 WaitableTimer 的主要功用, 现在再把它放在 &quot;线程同步&quot; 的话题中讨论有点不合适了, 就要结束它. //重新看看那个 APC 回调函数的格式: procedur ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnZ2nz.html" rel="bookmark" class="title">ZBrush中Clip剪切笔刷的使用方法</a>
					<div>
						  Clip剪切笔刷可以对模型网格进行剪切操作,也可以叫做剪切笔刷.接下来看一下Clip切割笔刷在ZBrush中是如何使用的. 步骤一 单击左工具架最上端的雕刻笔刷图标,弹出浮动面板,选择红框内的任意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AEL6p.html" rel="bookmark" class="title">借Word规范论坛发帖格式</a>
					<div>
						大家清楚,论坛的帖子左侧显示发帖人和回帖人的昵称.头像.身份等信息,右侧显示的才是帖子内容.在标准的1024×768分辨率下,帖子每行最多显示79个英文字符(大概39个汉字).虽然贴文章时,论坛会自动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEwByb.html" rel="bookmark" class="title">Camera FV 5相机声音怎么关闭</a>
					<div>
						  很多人都在使用专业相机Camera FV 5,不过,很多用户都不知道,要怎么关闭相机声音.今天,小编就来跟大家分享Camera FV 5怎么关闭相机声音. 1.首先,安装安软市场的新版专业相机 C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2qA5p.html" rel="bookmark" class="title">PHP CodeIgniter框架的工作原理研究</a>
					<div>
						 这篇文章主要介绍了PHP CodeIgniter框架的工作原理研究,本文首先分析了它的工作流程,然后总结了它的工作原理,需要的朋友可以参考下     CodeIgniter(以下简称CI,官网以及中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2ogdM.html" rel="bookmark" class="title">Linux命令提示符如何按照自己的习惯修改&quest;</a>
					<div>
						  原本的 [root@localhost ]$ 看久了难免让人厌倦.如果按自己的习惯修改,既能看着舒服,又能提高&quot;逼格&quot;.下面小编就为大家详细介绍Linux命令提示符如何按照自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42eJrM.html" rel="bookmark" class="title">PS设计字体太少 怎么安装字体</a>
					<div>
						  很多朋友都喜欢用PS 做下图,期间少不了会用文字来渲染图,用什么样的字体好呢?电脑里自带的字体好难看,怎么办呢?我们当然是去找字体咯! 找字体很简单,网上随便搜搜就一大堆.但问题来了,有朋友会问: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLa5Wvz.html" rel="bookmark" class="title">XP中根据端口号或PID查看进程</a>
					<div>
						  1.查看任务列表 tasklist 2.查看端口号与PID关联 netstat -ano 3.终止进程 taskkill /PID 1448    1.查看任务列表    tasklist 2.查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72lgrp.html" rel="bookmark" class="title">HADOOP在处理HIVE时权限错误的解决办法</a>
					<div>
						今天,小乔操作时发现问题:   org.apache.hadoop.security.AccessControlException: Permission denied: user=root, acc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7kvOM.html" rel="bookmark" class="title">iphone6中Safari闪退怎么修复？Safari闪退修复方法</a>
					<div>
						方法一 把你的iphone手机系统调成英文(设置图-通用-最后一项 前面一组 倒数第二个 里面第一个) 方法二 重启iPhone/iPad设备(按住home键加顶部电源键就重启了) 方法三 升级固件或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJ48op.html" rel="bookmark" class="title">android fragment-fragmentactivity中了用了办法来解决每次点击后重复加载ui，但是没效，求大神指教</a>
					<div>
						问题描述 fragmentactivity中了用了办法来解决每次点击后重复加载ui,但是没效,求大神指教 package com.doone.changeverday.ui.fragmrnt; imp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NZd6z.html" rel="bookmark" class="title">尼康黑斑门一年多未解 用户欲集体维权</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 孟岩峰 自3·15曝光尼康D600 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mxo0yPb.html" rel="bookmark" class="title">android-Android的GridView滚动速度计算</a>
					<div>
						问题描述 Android的GridView滚动速度计算 怎么计算出Android的GridView的滚动速度,用于GridView加载网络图片,当滚动过快就不加载图片,滚动慢就加载图片 解决方案 跟运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZlaOb.html" rel="bookmark" class="title">【Android】Parse 开发笔记（4）&mdash;&mdash; Push Notifications（上）</a>
					<div>
						前言 合理的使用Push服务,能极大提高用户活跃度,本博&lt;Parse Push快速入门指南&gt;仅简单介绍和使用了一下Parse的推送服务,这里介绍更多的使用方法和技巧.系列文章分两篇来介绍P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQvxLp.html" rel="bookmark" class="title">浏览器-jq&period;ajax&plus;json&plus;ashx&plus;数据库交互</a>
					<div>
						问题描述 jq.ajax+json+ashx+数据库交互 jq.ajax+json+ashx+数据库交互 只有在(chrome,火狐)浏览器调试的时候才能获得需要的效果,但IE任何时候都可以.各位,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kKYoM.html" rel="bookmark" class="title">由光年论坛的关闭理解分析关闭光年的原因&lpar;二&rpar;</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在前面写到了国平老师关闭光年的原因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKvBDb.html" rel="bookmark" class="title">跨平台物联网通讯框架 ServerSuperIO v1&period;1（SSIO）</a>
					<div>
						SSIO的更新 在SSIO上增加了UDP通讯方式,可以到Git上 下载源代码.在原来的项目中,远端的设备与中心站的数据交互并没有使用过UDP方式.这种短连接的通讯链路,不容易维护,主要体现在:(1)持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Ry8jz.html" rel="bookmark" class="title">数据库-c&num;连接sybase的时候报错</a>
					<div>
						问题描述 c#连接sybase的时候报错 ERROR=Parse failure on line 1 of statement 'use alerts', at or near 'alerts' 一直 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKJq3b.html" rel="bookmark" class="title">Python深入01 特殊方法与多范式</a>
					<div>
						原文:Python深入01 特殊方法与多范式 作者:Vamei 出处:http://www.cnblogs.com/vamei 欢迎转载,也请保留这段声明.   Python一切皆对象,但同时,Pyt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXjGxb.html" rel="bookmark" class="title">多线程 银行账户问题</a>
					<div>
						问题描述 假设TOM有个账户,姓名和余额存在已知文本innitial.txt中,请使用两个线程模拟ATM及其操作存取文件(input1.txt,input2.txt),记录每次的存取款前的余额值和后的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnm6NM.html" rel="bookmark" class="title">AngularJS &ndash; 实现基于角色访问控制的 GUI</a>
					<div>
						这些天我们忙于应用的前端工作,我们主要使用angular完成的.最近的一个需求是基于角色访问GUI.一个用户可以有多个角色,而它应只能访问授权给他的那一部分GUI. 我们主要通过在2个层次限制应用的G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg4o0M.html" rel="bookmark" class="title">职介机构称美IT人才就业前景大幅改善</a>
					<div>
						北京时间7月1日晚间消息,据国外媒体报道,职业介绍中介机构CV Screen称,美国IT人才就业前景有了很大改善. CV Screen表示,1个月内IT人才需求增长了25%,每个工作岗位申请人数减少了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLr48M.html" rel="bookmark" class="title">互联网之父称可能投诉宽带商滥用市场力量</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅   网消息 美国参议院商业委员会于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAELOKM.html" rel="bookmark" class="title">visual studio 2010-  VS2010的调试问题</a>
					<div>
						问题描述 VS2010的调试问题 HEAP[fchang.exe]: Invalid address specified to RtlValidateHeap( 005F0000 002ACA58 ) ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
